from simplepam import authenticate

class PAM:

    def __init__(self, pam_args, logger=None):
        """Set up PAM object. Throws exceptions on invalid config"""

        required_fields = ['service']

        for field in required_fields:
            setattr(self, field, pam_args[field] or raise_KeyError(msg='%s \
                cannot be None' % (field)))

    def authenticate(self, username, password):
        return authenticate(username, password, self.service)

    def raise_KeyError(msg=''):
        raise KeyError(msg)
